let port=[];
let leds=[];
let data=new Uint8Array(8);

function send(val,a1,a2){
	data[0]=5;
	data[1]=val;
	data[2]=a1;
	data[3]=a2;
  data[4]=0;
	data[5]=0;
  data[6]=0;
	data[7]=0;
	port[0].sendReport(0,data);
}

async function btn(){
port=await navigator.hid.requestDevice({filters:[]});
port[0].open();
port[0].oninputreport=inputreport;
port.open=true;
}

function ide(e){return document.getElementById(e);}

function setup() {
  createCanvas(400, 400);
  for(let i=0;i<5;i++){
    leds.push(ide("led"+i));
  }
  port.open=false;
}

let v=[];
function inputreport(e){
  v=new Uint8Array(e.data.buffer);
}


i=0;
function draw() {
  i++;
  (!port.open)?background(255,0,0):background(0,255,0);
  if(port.open){
    push();
    if(v[0]&0x10) fill(255,0,0); else fill(0,0,255);
      ellipse(20,100,10);
    if(v[0]&0x20) fill(255,0,0); else fill(0,0,255);
      ellipse(40,100,10);
    if(v[0]&0x01) fill(255,0,0); else fill(0,0,255);
      ellipse(60,100,10);
    if(v[0]&0x40) fill(255,0,0); else fill(0,0,255);
      ellipse(80,100,10);
    if(v[0]&0x80) fill(255,0,0); else fill(0,0,255);
      ellipse(100,100,10);
    pop();
   
    leds[0].value=(v[0]&0x10)?1:0;
    leds[1].value=(v[0]&0x20)?1:0;
    leds[2].value=(v[0]&0x01)?1:0;
    leds[3].value=(v[0]&0x40)?1:0;
    leds[4].value=(v[0]&0x80)?1:0;
  
    
    ellipse(map(v[2],0,255,0,width),200,20);
    ellipse(map(v[3],0,255,0,width),300,20);
   
    send(1<<map(mouseX,0,width,0,8),map(mouseY,0,height,0,255),(Math.sin(i/20)+1)*100);
  }
}